// nneonneo's AJAX shoutbox
// Version 1.20
shoutFile=escape(shoutFile);

// Set up Behaviour
var myrules = {
	'#shout-form' : function(element){
		element.onsubmit = function(){
			return false;
		}
	},
	
	'#shout-text' : function(element){
		element.onkeypress = function(evt){
			return onKP(element, evt);
		}
		element.onfocus = function() {
			onF(element);
		}
	},
	
	'#shout-button' : function(element){
		element.onclick = function(){
			doSend();
		}
	}
};

var guest;

Behaviour.register(myrules);

// onKeyPress event handler for the two textboxes
function onKP (element, evt) {
	evt = (evt) ? evt : (window.event) ? event : null;

	var charCode;
	if (evt)
	charCode = (evt.charCode) ? evt.charCode : ((evt.keyCode) ? evt.keyCode : ((evt.which) ? evt.which : 0));

	if (charCode == 13 || charCode == 3) {
		doSend();
		return false;
	}
}

// onFocus event handler for the two textboxes
function onF (element) {
	element.value = "";
	defocus(element);
}

// Clear the onFocus event handler and set the foreground color to black.
function defocus(element) {
	element.onfocus = null;
	element.style.color = null;
}

var chatscroll = new Object();

chatscroll.Pane = function(scrollContainerId){
	this.bottomThreshold = 20;
	this.scrollContainerId = scrollContainerId;
	this._lastScrollPosition = null; /* fixed 2008-05-27: changed from 100000000 to null */
}

chatscroll.Pane.prototype.activeScroll = function(){

	var _ref = this;
	var scrollDiv = document.getElementById(this.scrollContainerId);
	var currentHeight = 0;
	
	var _getElementHeight = function(){
		var intHt = 0;
		if(scrollDiv.style.pixelHeight)intHt = scrollDiv.style.pixelHeight;
		else intHt = scrollDiv.offsetHeight;
		return parseInt(intHt);
	}

	var _hasUserScrolled = function(){
		if(_ref._lastScrollPosition == scrollDiv.scrollTop || _ref._lastScrollPosition == null){
			return false;
		}
		return true;
	}

	var _scrollIfInZone = function(){
		if( !_hasUserScrolled() ||
				(currentHeight - scrollDiv.scrollTop - _getElementHeight() <= _ref.bottomThreshold)){
				scrollDiv.scrollTop = currentHeight;
				_ref._isUserActive = false;
		}
	}


	if (scrollDiv.scrollHeight > 0)currentHeight = scrollDiv.scrollHeight;
	else if(scrollDiv.offsetHeight > 0)currentHeight = scrollDiv.offsetHeight;

	_scrollIfInZone();

	_ref = null;
	scrollDiv = null;

}
var divScroll;

// Set off the AJAX call to load the chat form into the empty yShout div
function loadChat() {
	if ($("yshout").style.display=="none") return;
	if(checkDuplicates)
	{
		if(get_cookie("yShout_open"))
		{
			$("yshout").innerHTML="Shoutbox loaded in another window. Retrying...";
			setTimeout("loadChat()",Math.random()*1000+1000/*between 1 and 2 seconds*/);
			return;
		}
	}
	// onbeforeunload is IE specific, and is used because onunload doesn't fire immediately
	window.onbeforeunload = window.onunload = unload_shoutbox;
	if ($("yshout")) {
		new ajax (yshout_php, { 
			postBody: 'reqtype=init&file=' + shoutFile,
			update: $('yshout'),
			onComplete: loadDone
		});
	}
	set_cookie("yShout_open","true",duplicateWait/*seconds*/);
}

function unload_shoutbox() {
	delete_cookie("yShout_open");
	request.abort();
}

// Re-apply Behaviour after the chat loads
function loadDone() {
	setTimeout("Behaviour.apply()", 5);
	setTimeout("setupChat()", 5);
}

var oldNameBackgroundColor, oldTextBackgroundColor;

function setupChat() {
	divScroll = new chatscroll.Pane('shouts');
	objDiv = document.getElementById('shouts');
	objDiv.scrollTop = objDiv.scrollHeight;
	if(!$("forum-name")) // do NOT refresh if the form didn't show up.
		return;
	startRefresh();
	if($("forum-name").disabled) guest=false;
	else guest=true;
}

function complex_escape(text) {
	return escape(textToEntities(text.replace(/&#/g, "&#38;#"))).replace(/\+/g, "%2B");
}

// Send the message
function doSend() {
	userdata='';
	if (guest) {
		if($("forum-name").value=='')
		{
			alert("Please enter a username.");
			return;
		}
		username=complex_escape($F("forum-name"));
		userdata='&username='+username;
		set_cookie("username",username,2*365*24*3600);
	}
	if (formValidate() && $("shout-text").value) {
		var toShout = complex_escape($F("shout-text"));
		floodControl();
		new ajax (yshout_php, {
			postBody: 'reqtype=shout&shout=' + toShout + '&file=' + shoutFile + userdata,
			update: $('shouts'),
			onComplete: shoutDone
		});
	}
}

function autoShout(theText) {
	new ajax (yshout_php, { 
			postBody: 'reqtype=autoshout&shout=' + theText + '&file=' + shoutFile,
			update: $('shouts'),
			onComplete: shoutDone
		});
}

function ajaxGet(args) {
	new ajax (yshout_php+'&file='+shoutFile+'&'+args, { 
			update: $('shouts'),
			onComplete: shoutDone
		});
}

function getURL(args) {
	return yshout_php+'&file='+shoutFile+'&'+args;
}

function goTo(args) {
	if(request) request.abort();
	document.location=getURL(args);
}

// Start refreshing the chat after a message has been sent
function shoutDone() {
	$('shouts').innerHTML = this.transport.responseText;
	oldShouts = $('shouts').innerHTML;
	startRefresh();
}

var refreshSet = false;

function startRefresh() {
	if (!refreshSet) {
		setTimeout("doRefresh()", refreshTime);
		refreshSet = true;
	}
}

function schedRefresh() {
	if (refreshSet) {
		setTimeout("doRefresh()", refreshTime);
	}
}

// Validate the form to ensure that the fields are filled
function formValidate() {
	var shoutText = $F("shout-text");

	var textValid = true;

	if (shoutText == "Shout text" || shoutText == "")
		textValid = false;

	if (!textValid) {
		changeClass($("shout-text"), "shout-invalid");
		$("shout-text").focus();
		return false;
	} else {
		changeClass($("shout-text"), "shout-valid-shout");
	}

	return true;
}

function ltrim(text) {
	return text.replace(/^\s*/g,'');
}
var request;
// This gets called each refresh; it reloads the shoutboxes content.
var oldShouts = null;
function doRefresh() {
	if (oldShouts != null && ltrim(oldShouts) != ltrim($("shouts").innerHTML) && get_cookie("shoutSound") == "true")
		soundManager.play('sound');
	oldShouts = $("shouts").innerHTML;
	if($("yshout").style.display == "none") {refreshSet = false; return;};
	set_cookie("yShout_open","true",duplicateWait/*seconds*/);
	request=new ajax (yshout_php, { 
		postBody: 'reqtype=refresh&file=' + shoutFile,
		update: $('shouts'),
		onComplete: schedRefresh
	});
}

function floodControl() {
	$("shout-text").disabled = true;
	$("shout-text").value = "";
	Form.disable($("shout-form"));
	setTimeout("enableShout()", floodTime);

}

function enableShout() {
	Form.enable($("shout-form"));
	$("shout-text").value = "";
	if(!guest) $("forum-name").disabled = true;
	$("shout-text").disabled = false;

	setTimeout('$("shout-text").focus()', 0);
}

function changeClass(element, newClass) {
	element.className = newClass;
}

function set_cookie( name, value, expires, path, domain, secure ) 
{
	// set time, it's in milliseconds
	var today = new Date();
	today.setTime( today.getTime() );
	
	/*
	if the expires variable is set, make the correct 
	expires time, the current script below will set 
	it for x number of days, to make it for hours, 
	delete * 24, for minutes, delete * 60 * 24
	*/
	if ( expires )
	{
		expires = expires * 1000;
	}
	var expires_date = new Date( today.getTime() + (expires) );
	
	document.cookie = name + "=" +escape( value ) +
	( ( expires ) ? ";expires=" + expires_date.toGMTString() : "" ) + 
	( ( path ) ? ";path=" + path : "" ) + 
	( ( domain ) ? ";domain=" + domain : "" ) +
	( ( secure ) ? ";secure" : "" );
}

// this function gets the cookie, if it exists
function get_cookie( name ) {
	var start = document.cookie.indexOf( name + "=" );
	var len = start + name.length + 1;
	if ( ( !start ) &&
	( name != document.cookie.substring( 0, name.length ) ) )
	{
	return null;
	}
	if ( start == -1 ) return null;
	var end = document.cookie.indexOf( ";", len );
	if ( end == -1 ) end = document.cookie.length;
	return unescape( document.cookie.substring( len, end ) );
}

function delete_cookie ( cookie_name )
{
	var cookie_date = new Date ( );  // current date & time
	cookie_date.setTime ( cookie_date.getTime() - 1 );
	document.cookie = cookie_name += "=; expires=" + cookie_date.toGMTString();
}
